function LootSquid:SafeCall(func,...)
    print("safecall..".. (...))

    if func == nil then
        LootSquid:LogError("nil is not accepted as function argeument.")
        return
    end

    if LootSquid.debug.bypassSafeCalls then
        return true, func(...)
    else
        return pcall(func, ...)
    end
end

function LootSquid:LogDebug(message, verbosity)
    if LootSquid.debug.logging then
        DEFAULT_CHAT_FRAME:AddMessage(format("|cFFFFAA00%s:|r %s", "LootSquid [Debug]", tostring(message)))
    end
end

function LootSquid:LogInfo(message)
    DEFAULT_CHAT_FRAME:AddMessage(format("|cFFFFAA00%s:|r %s", "LootSquid [Info]", tostring(message)))
end

function LootSquid:LogError(message)
    DEFAULT_CHAT_FRAME:AddMessage(format("|cFFFFAA00%s:|cFFFF0000 %s", "LootSquid [Error]", tostring(message)))
end

function LootSquid:strStartsWith(String, Start)
    return string.sub(String, 1, string.len(Start)) == Start
end

function LootSquid:strEndsWith(String, End)
    return End == '' or string.sub(String, -string.len(End)) == End
end

-- Sort a Table[] in Lua
-- http://stackoverflow.com/a/15706820
function LootSquid:spairs(t, order)
    -- collect the keys
    local keys = {}
    for k in pairs(t) do keys[#keys + 1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys
    if order then
        table.sort(keys, function(a, b)
            if a == nil and b == nil then
                return false
            end
            if a == nil then
                return false
            end
            if b == nil then
                return true
            end
            return order(t, a, b)
        end)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i]]
        end
    end
end

-- http://stackoverflow.com/a/2705804
function LootSquid:tablelength(T)
    local count = 0
    for _ in pairs(T) do count = count + 1 end
    return count
end

LootSquid.components.utils = true